unit starsfrm;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF} SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_scene, dx_utils, ExtCtrls, dx_controls, dx_vgcore, dx_vglayer;

type
  TfrmStars = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    Timer1: TTimer;
    ObjectLayer: TdxGUIObjectLayer;
    Root2: TvxLayout;
    Text1: TvxText;
    Rectangle1: TvxRectangle;
    textFps: TvxText;
    dxBitmapList1: TdxBitmapList;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DoTick(Sender: TObject; time, deltaTime: single);
  end;

var
  frmStars: TfrmStars;

implementation

{$R *.dfm}

procedure TfrmStars.DoTick(Sender: TObject; time, deltaTime: single);
begin
  if (TdxVisualObject(Sender).Position.X < TdxVisualObject(Sender).Width / 2) then
    TdxVisualObject(Sender).Velocity.X := Abs(TdxVisualObject(Sender).Velocity.X);
  if (TdxVisualObject(Sender).Position.X > dxScene1.Width - (TdxVisualObject(Sender).Width / 2)) then
    TdxVisualObject(Sender).Velocity.X := -Abs(TdxVisualObject(Sender).Velocity.X);
  if (TdxVisualObject(Sender).Position.Y < TdxVisualObject(Sender).Height / 2) then
    TdxVisualObject(Sender).Velocity.Y := Abs(TdxVisualObject(Sender).Velocity.Y);
  if (TdxVisualObject(Sender).Position.Y > dxScene1.Height - (TdxVisualObject(Sender).Height / 2)) then
    TdxVisualObject(Sender).Velocity.Y := -Abs(TdxVisualObject(Sender).Velocity.Y);
end;

procedure TfrmStars.FormCreate(Sender: TObject);
var
  Star: TdxGUIObjectLayer;
  Obj: TdxProxyObject;
  Ellipse: TvxShape;
  Text: TvxText;
  i: integer;
begin
  for i := 0 to 9 do
  begin
    Star := TdxGUIObjectLayer.Create(Self);
    Star.Fill.Style := vgBrushNone;
    Star.Parent := Root1;
    Star.Position.Point := dxPoint(50 + random(dxScene1.Width - 100), 50 + random(dxScene1.Height - 100), 0);
    Star.Width := 32 + random(30);
    Star.Height := 32 + random(30);
    Star.Opacity := random;
    Star.Velocity.Point := dxPoint(-120 + random(240), -120 + random(240), 0);
    Star.OnTick := DoTick;
    Star.Resolution := 80;

    case random(2) of
      1: begin
        Ellipse := TvxRectangle.Create(Self);
        TvxRectangle(Ellipse).xRadius := random(10);
        TvxRectangle(Ellipse).yRadius := TvxRectangle(Ellipse).xRadius;
      end;
    else
      Ellipse := TvxEllipse.Create(Self);
    end;

    case random(2) of
      1: begin
        Ellipse.Fill.Style := vgBrushGradient;
        Ellipse.Fill.Gradient.Style := vgRadialGradient;
        Ellipse.Fill.Gradient.Points[0].IntColor := $00FFFFFF;
        Ellipse.Fill.Gradient.Points[1].IntColor := $FF000000 or random($FFFFFF);
      end
    else
      Ellipse.Fill.Style := vgBrushSolid;
      Ellipse.Fill.SolidColor := $FF000000 or random($FFFFFF);
    end;

    Ellipse.Stroke.Style := vgBrushSolid;
    Ellipse.Stroke.SolidColor := $FF000000 or random($FFFFFF);
    Ellipse.StrokeThickness := 2;

    Star.AddObject(Ellipse);

    Text := TvxText.Create(Self);
    Text.Parent := Ellipse;
    Text.Align := vaCenter;
    Text.Text := IntToStr(i);
  end;
  ObjectLayer.BringToFront;
end;

procedure TfrmStars.Timer1Timer(Sender: TObject);
begin
  textFps.Text := IntToStr(Trunc(dxScene1.Fps)) + ' FPS';
end;

end.
